import { AccountingSetupService } from '../services/accountingSetupService.js'
import { sendError } from '../utils/response.js'
// import { OftenError } from '../utils/oftenError.js'
import { GeneralService } from '../share/generalservice.js';
import { trim_all_array } from '../utils/trim.js'
import { verifyToken, generateToken } from '../utils/token.js'

export class accountingSetup {

  constructor() {
    this.generalService = new GeneralService();
    this.AccountingSetupService = new AccountingSetupService();
  }

  async onNavigate(req, res) {
    this.generalService.devhint(1, 'accountingSetup.js', 'onNavigate() start');
    let organization = req.body.organization;
    const prommis = await this.onAccountingSetup(req, res, organization);
    return prommis;
  }

  async onAccountingSetup(req, res, database) {
    let idx = -1
    let result = []
    try {
      // let username = req.body.request.username;
      // let password = req.body.request.password;
      let token = req.body.request.token;
      const decoded = verifyToken(token);

      database = decoded.organization


      result = await this.AccountingSetupService.getAccountingSetup(database); // เช็คกับ db กลาง ส่ง jwttoken ออกมา
    //   this.generalService.devhint(1, 'accountingSetup.js', 'Login success');
    } catch (error) {
      idx = 1;
    } finally { 
      if (idx === 1) return sendError('เกิดข้อผิดพลาดไม่คาดคิดเกิดขึ้น', 'Unexpected error');
      if (!result) return sendError('ชื่อผู้ใช้หรือรหัสผ่านไม่ถูกต้อง', 'Invalid credentials');
      // แยกกลุ่ม income / expense
      let income = result.filter(item => item.dtltblcod === 'ACTCAT_INC').map(({ dtltblcod, ...rest }) => rest);

      let expense = result.filter(item => item.dtltblcod === 'ACTCAT_EXP').map(({ dtltblcod, ...rest }) => rest);

      let arydiy = { 
        income ,
        expense 
      };

    return arydiy
    }
  }
}
